/*
  LockExtensions - Plugin for KeePass 1
  Copyright (C) 2010 Nikolaus Hammler <niki@hammler.info>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#define _WIN32_WINNT  0x0500

#include "KeePassLibCpp/SDK/KpSDK.h"

#include "resource.h"

#define PLUGIN_NAME			_T("LockExtensions")
#define WND_CLASSNAME		_T("LockExtWndCls")
#define CONFIG_ITEM_TIME	_T("Plugin_LockExt_IdleTime")
#define CONFIG_ITEM_STANDBY	_T("Plugin_LockExt_Standby")
#define CONFIG_ITEM_HOTKEY	_T("Plugin_LockExt_HotKey")

#define TIMER_ID			1984
#define ID_FILE_LOCK		32867

// idle 5 minutes
#define DEFAULT_TIMEOUT		5
#define DEFAULT_STANDBY		FALSE

BOOL StartWindow();

class LockExtensions : public IKpPlugin
{
public:
	LockExtensions();

	KP_DECL_IUNKNOWN;

	STDMETHODIMP_(BOOL) OnMessage(DWORD dwCode, LPARAM lParamW, LPARAM lParamL);

	STDMETHODIMP_(LPCTSTR) GetProperty(LPCTSTR lpName);
	STDMETHODIMP SetProperty(LPCTSTR lpName, LPCTSTR lpValue);

	STDMETHODIMP_(DWORD) GetMenuItemCount();
	STDMETHODIMP_(KP_MENU_ITEM*) GetMenuItems();

private:
	void SaveSettings();
	void LoadSettings();
	KP_DECL_STDREFIMPL;
};
